<?php
/*

Plugin Name: DG Random Image
Plugin URI: http://www.dutchguys.com/plugins
Description: Displays a random image from one of the children of a named page.<br> Read more about in on <a href="http://www.dutchguys.com">dutchguys.com</a>
Version: 1.0
Author: Menno Dekker
Author URI: http://www.dutchguys.com
License: GPL
*/

/**
 * Display a random image attached to a named page or one of it's children. 
 *
 * @param array $args key (default value) <b>title</b> (Gallery) <b>class</b> (null) <b>x</b> (125) <b>y</b> (125)
 * @return thumbnail image linked to page
 */
function DG_Random_Image($args = '') {

    static $aImages = array();
    static $sPageTitle = '';

	if ( is_array($args) ) {
          $r = $args;
    } else {
          parse_str($args, $r);
	}
	
	//Parse the defaults
    $defaults = array('title' => 'Gallery', 'class' => '', 'x' => 125, 'y' => 125);
    $r = array_merge($defaults, $r);
    
    //Now check if we used this page before and if so wether we have images or not
    if (count($aImages)==0 or $sPageTitle != $r['title'] ) {
    	$sPageTitle = $r['title'];
		$c = array('child_of' => get_page_by_title($r['title'])->ID,	         
	        	   'name' => 'page_id'
	 	          );
		$pages = get_pages($c);
		//Now loop through all the child pages to find attached pictures
		foreach ($pages as $pagg) {
			$attachments = get_children( array('post_parent' => $pagg->ID, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
			if ( !empty($attachments) ) {
				foreach ($attachments as $att) {
					$aImages[] = array( 'ID' => $att->ID, 'parent' => $pagg->guid, 'title' => $pagg->post_title);
				}
			}
		}
     }
	//Okay we have an array containing image id, page url and page title
	$rId = rand(0, count($aImages)-1);
	$aImg = wp_get_attachment_image_src($aImages[$rId]['ID'], 'thumbnail', false);
	if ($r['']!=='') $sClass = ' class="' . $r['class'] . '"';
	$alt = ' alt="' . $aImages[$rId]['title'] . '"';
	$title = ' title="' . $aImages[$rId]['title'] . '"';
	$sReturn = '<a href="' . $aImages[$rId]['parent'] . '"><img src="' . $aImg[0] . '" width="' . $r['x'] . '" height="' . $r['y'] . '"' . $sClass . $alt . $title . '></a>';
	return $sReturn;
}
?>